#!/usr/bin/env python

"""Simple GStreamer tone generator.
"""

import time

import pygst
pygst.require('0.10')
import gst


class Beep:
    def __init__(self, frequency=440):
        self.pipeline = gst.Pipeline('mypipeline')

        self.audiotestsrc = gst.element_factory_make('audiotestsrc', 'audio')
        self.audiotestsrc.set_property('freq', frequency)
        self.pipeline.add(self.audiotestsrc)

        self.sink = gst.element_factory_make('alsasink', 'sink')
        self.pipeline.add(self.sink)

        self.audiotestsrc.link(self.sink)

        self.pipeline.set_state(gst.STATE_PLAYING)


if __name__ == '__main__':
    import argparse

    parser = argparse.ArgumentParser(description='Play a pure tone')
    parser.add_argument(
        '-f', '--frequency', type=float, default=440,
        help='tone frequency in Hz')

    args = parser.parse_args()

    start=Beep(frequency=args.frequency)
    while True:
        time.sleep(10)
